/*
@    aflt Version 1.49

      2004/12/31 ˁ@P
*/

#include <windows.h>
#include <commctrl.h>
#include <mmsystem.h>
#include <time.h>
#include "vbmp3s.h"
#include <vector>
#include <string>
#include <fstream>
#include "resource.h"

using namespace std;

const int MAXFILE = 99;

const int IDM_LOAD =   11;
const int IDM_SAVE =   12;
const int IDM_REPEAT = 13;
const int IDM_DELETE = 14;
const int IDM_LIST =   15;
const int IDM_ABOUT =  16;

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK LabelProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK SwitchProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK PlayProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK PauseProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK StopProc(HWND, UINT, WPARAM, LPARAM);

void layout(int,int);
void play(int);
void getFiles(LPTSTR);
BOOL readBMP(LPCTSTR);
bool readTxt(LPCTSTR);
void createList(void);
void saveList(LPCTSTR);

HINSTANCE g_hInstance;

HWND hwMain, hwLabel, hwSwitch, hwTrack, hwPlay, hwPause, hwStop;

HFONT hFontName, hFontTime, hFontNum;
HPEN hPenMH, hPenMB;
HBRUSH hBrushM, hBrushLb, hBrushSw, hBrushBtnB, hBrushBtn, hBrushOn, hBrushOff;
HBITMAP hBG, hBMP;
HDC hdcBG, hdcBMP;
RECT recTime, recMain;
HMENU hMenu, hMenuP, hmList;

DWORD dwLength, dwMIndex, dwTime, dwSTime, dwType;
BOOL fPlay = FALSE, fOnPlay = FALSE, fOnPause = FALSE, fOnStop = FALSE, fRepeat = FALSE, fDll;

string title;
vector<string> exts, FileList;

InputInfo mInfo;

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,PSTR szCmdLine,int iCmdShow){

	MSG  msg;
	WNDCLASS  wndclass;

	char lpszCDir[MAX_PATH + 1], lpszFile[MAX_PATH + 1];
	LPTSTR lpszStr = NULL;

	hInstance = hInstance; /* vZX̃nhۑ */

	fDll = vbmp3_init(); /* VBMP3 */

	hBrushM = CreateSolidBrush(RGB(80, 0, 192)); /* {̂̐F */
	hPenMH = CreatePen(PS_SOLID, 1, RGB(160, 96, 255)); /* {̘g̐F */
	hPenMB = CreatePen(PS_SOLID, 1, RGB(32, 0, 96)); /* {̘g̐F */
	hBrushLb = CreateSolidBrush(RGB(0, 64, 0));/* x̐F */
	hBrushSw = CreateSolidBrush(RGB(240, 112, 32)); /* XCb`̐F */
	hBrushBtnB = CreateSolidBrush(RGB(0, 0, 0)); /* XCb`g̐F */
	hBrushBtn = CreateSolidBrush(RGB(192, 192, 200)); /* {^n̐F */
	hBrushOn = CreateSolidBrush(RGB(64, 224, 128)); /* {^I̐F */
	hBrushOff = CreateSolidBrush(RGB(64, 64, 64)); /* {^It̐F */

	srand((unsigned)time(NULL)); /* 񏉊 */

	/* CEChEpEChENX */
	wndclass.style         = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = LoadIcon (NULL, "IDI_ICON1");
	wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(LTGRAY_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = "CWindow";
	RegisterClass(&wndclass);

	/* xpEChENX */
	wndclass.style         = CS_HREDRAW | CS_VREDRAW|CS_DBLCLKS;
	wndclass.hIcon         = NULL;
	wndclass.lpfnWndProc   = LabelProc;
	wndclass.lpszClassName = "LabelWindow";
	RegisterClass(&wndclass);

	/* XCb`pEChENX */
	wndclass.lpfnWndProc   = SwitchProc;
	wndclass.lpszClassName = "SwitchWindow";
	RegisterClass(&wndclass);

	/* vC{^pEChENX */
	wndclass.lpfnWndProc   = PlayProc;
	wndclass.lpszClassName = "PlayWindow";
	RegisterClass(&wndclass);

	/* |[Y{^pEChENX */
	wndclass.lpfnWndProc   = PauseProc;
	wndclass.lpszClassName = "PauseWindow";
	RegisterClass(&wndclass);

	/* Xgbv{^pEChENX */
	wndclass.lpfnWndProc   = StopProc;
	wndclass.lpszClassName = "StopWindow";
	RegisterClass(&wndclass);

	hwMain=CreateWindow("CWindow","aflt",
	  WS_POPUP,CW_USEDEFAULT,CW_USEDEFAULT,250,100,
      NULL,NULL,hInstance,NULL);

	/* Đgqݒ */
	exts.push_back("*.mid");
	exts.push_back("*.wav");
	exts.push_back("*.mp3");
	exts.push_back("*.wma");

	/* JgfBNg擾 */
	GetCurrentDirectory(MAX_PATH+1,lpszCDir);

	if (lpszCDir[strlen(lpszCDir)-1]!='\\') /* Ōオ"\" H */
		lstrcat(lpszCDir,"\\"); /* JgfBNg */

	lstrcpy(lpszFile,lpszCDir);
	lstrcat(lpszFile,"bg.bmp");

	readBMP(lpszFile); /* wiǂݍ */

	ShowWindow(hwMain,iCmdShow); /* EChE\ */
	UpdateWindow(hwMain);        /* ĕ` */
	DragAcceptFiles(hwMain,TRUE); /* hbOhbv */

	dwMIndex=0;
	dwTime=0;
	dwLength=0;

	int iCmdLength=lstrlen(szCmdLine);

	if (iCmdLength>0) { /* R}hC */

		bool fOneFile=false,fTest=true;

		if (szCmdLine[0]=='"' && szCmdLine[iCmdLength-1]=='"') {

			for (int i=1;i<lstrlen(szCmdLine)-1;i++)
				if (szCmdLine[i]=='"')
					fTest=false;

			fOneFile=fTest;

		}

		/* g[NɃt@C؂蕪 */
		if (fOneFile) {

			szCmdLine[iCmdLength-1]=0;
			lpszStr=szCmdLine+1;

		} else
			lpszStr=strtok(szCmdLine," ");

		if (GetFileAttributes(lpszStr)==FILE_ATTRIBUTE_DIRECTORY) {

			getFiles(lpszStr);

			if (fOneFile)
				lpszStr=NULL;
			else
				lpszStr=strtok(NULL," ");

		}

		/* ̃t@C擾 */
		while(lpszStr!=NULL && FileList.size()<MAXFILE) {
 
			/* t@CXgɒǉ */
			FileList.push_back(lpszStr);

			/* g[NɃt@C؂蕪 */
			if (fOneFile)
				lpszStr=NULL;
			else
				lpszStr=strtok(NULL," ");

		}

		if (FileList.size()>0)
			play(-1);

	} else { /* R}hCȂ */

		lstrcpy(lpszFile,lpszCDir);
		lstrcat(lpszFile,"list.txt");

		/* ȖXglist.txtΓǂݍ */
		readTxt(lpszFile);

		/* JgfBNg̃t@CT */
		if (FileList.size()==0)
			getFiles(lpszCDir);

		if (FileList.size()>0)
			play(-1);

	}

	while(GetMessage(&msg,NULL,0,0)) { /* bZ[W[v */

		TranslateMessage(&msg);
		DispatchMessage(&msg);

	}

	return msg.wParam ;

}

void getFiles(LPTSTR lpszDir) { /* fBNg̃t@C擾 */

	LPTSTR lpszPath;
	WIN32_FIND_DATA FindData;
	HANDLE fh;
	char wrk[MAX_PATH+1];

	if (lpszDir[strlen(lpszDir)-1]!='\\') /* Ōオ"\" H */
		lstrcat(lpszDir,"\\"); /* JgfBNg */

	lpszPath=(LPTSTR)GlobalAlloc(GPTR,MAX_PATH+1);

	/* t@Cw胊Xgexts̃t@Cwɍvt@CT */
	for (vector<string>::const_iterator i=exts.begin();i!=exts.end();i++) {

		lstrcpy(lpszPath,lpszDir);
		lstrcat(lpszPath,i->c_str());

		/* wfBNg̃t@CJn */
		fh=FindFirstFile(lpszPath,&FindData);

		if (fh!=INVALID_HANDLE_VALUE) {
	
			/* t@C쐬 */
			strcpy(wrk,lpszDir);
			strcat(wrk,FindData.cFileName);
			/* t@CXgɒǉ */
			FileList.push_back(wrk);
		
			while(FindNextFile(fh,&FindData) && FileList.size()<MAXFILE) {

				/* t@C쐬 */
				strcpy(wrk,lpszDir);
				strcat(wrk,FindData.cFileName);
				/* t@CXgɒǉ */
				FileList.push_back(wrk);

			}

			FindClose(fh);

		}

	}

	GlobalFree(lpszPath);

}

void layout(int width,int height) { /* {̓̕iCAEg */

	double lfWid1,lfHei1;

	lfWid1=(double)width/100.0;  /* {̂̉̂P */
	lfHei1=(double)height/100.0; /* {̂̍̂P */

	/* xzu */
	SetWindowPos(hwLabel,HWND_TOP,(int)(lfWid1*4),(int)(lfHei1*8),
	  (int)(lfWid1*92),(int)(lfHei1*22),SWP_NOZORDER);

	/* gbNp[zu */
	SetWindowPos(hwTrack,HWND_TOP,(int)(lfWid1*4),(int)(lfHei1*35),
	  (int)(lfWid1*92),(int)(lfHei1*22),SWP_NOZORDER);

	/* XCb`zu */
	SetWindowPos(hwSwitch,HWND_TOP,(int)(lfWid1*5),(int)(lfHei1*70),
	  (int)(lfWid1*7),(int)(lfHei1*20),SWP_NOZORDER);

	/* vC{^zu */
	SetWindowPos(hwPlay,HWND_TOP,(int)(lfWid1*15),(int)(lfHei1*70),
	  (int)(lfWid1*9),(int)(lfHei1*20),SWP_NOZORDER);

	/* |[Y{^zu */
	SetWindowPos(hwPause,HWND_TOP,(int)(lfWid1*27),(int)(lfHei1*70),
	  (int)(lfWid1*9),(int)(lfHei1*20),SWP_NOZORDER);

	/* Xgbv{^zu */
	SetWindowPos(hwStop,HWND_TOP,(int)(lfWid1*39),(int)(lfHei1*70),
	  (int)(lfWid1*9),(int)(lfHei1*20),SWP_NOZORDER);

	// t@CptHg쐬
	hFontName=CreateFont((int)(lfHei1*16),0,0,0,FW_SEMIBOLD,
	  FALSE,FALSE,FALSE,SHIFTJIS_CHARSET,OUT_DEFAULT_PRECIS,
	  CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
	  FIXED_PITCH|FF_DONTCARE,NULL);

	/* \ptHg쐬 */
	hFontTime=CreateFont((int)(lfHei1*14),0,0,0,FW_SEMIBOLD,
	  FALSE,FALSE,FALSE,SHIFTJIS_CHARSET,OUT_DEFAULT_PRECIS,
	  CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
	  FIXED_PITCH|FF_DONTCARE,NULL);

	/* Ȑ\ptHg쐬 */
	hFontNum=CreateFont((int)(lfHei1*12),0,0,0,FW_MEDIUM,
	  FALSE,FALSE,FALSE,SHIFTJIS_CHARSET,OUT_DEFAULT_PRECIS,
	  CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
	  FIXED_PITCH|FF_DONTCARE,NULL);

	/* \̈ݒ */
	recTime.left=(int)(lfWid1*50);
	recTime.top=(int)(lfHei1*70);
	recTime.right=(int)(lfWid1*95);
	recTime.bottom=(int)(lfHei1*90);

}

/* CEChEbZ[W */
LRESULT CALLBACK WndProc (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {

	HDC hdc;
	PAINTSTRUCT ps;
	static RECT rec;
	static int iDx,iDy,iOldX,iOldY;
	static char lpszFn[MAX_PATH+1],lpszFt[256];
	char lpszStr[32];
	DWORD i,dwPos,pos,dwDNum;
	HDROP hDrop;
	int w;
	POINT pt;
	static OPENFILENAME ofn,sfn;
	static PCHAR lpszOpen="J",lpszSave="Xgt@Cۑ";

	static BOOL drag;

	switch (iMsg) {

	case WM_CREATE:

		/* OPENFILENAME\̏ */
		ofn.lStructSize=sizeof(OPENFILENAME);
		ofn.hwndOwner=hwMain;
		ofn.hInstance=g_hInstance;
		ofn.lpstrFilter="t@C(*.mid;*.mp3;*.wma;*.wav)\0*.mid;*.mp3;*.wma;*.wav\0ׂẴt@C(*.*)\0*.*\0\0";
		ofn.lpstrCustomFilter=NULL;
		ofn.nMaxCustFilter=0;
		ofn.nFilterIndex=1;
		ofn.lpstrFile=lpszFn;
		ofn.nMaxFile=255;
		ofn.lpstrFileTitle=lpszFt;
		ofn.nMaxFileTitle=255;
		ofn.lpstrInitialDir=NULL;
		ofn.lpstrTitle=NULL;
		ofn.Flags=0;
		ofn.nFileOffset=0;
		ofn.nFileExtension=0;
		ofn.lpstrDefExt=NULL;
		ofn.lCustData=0;
		ofn.lpfnHook=NULL;
		ofn.lpTemplateName=NULL;
		ofn.lpstrTitle=lpszOpen;
		ofn.Flags=OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
		ofn.nFilterIndex=1;

		/* OPENFILENAME\̏ */
		sfn.lStructSize=sizeof(OPENFILENAME);
		sfn.hwndOwner=hwMain;
		sfn.hInstance=g_hInstance;
		sfn.lpstrFilter="ׂẴt@C(*.*)\0*.*\0\0";
		sfn.lpstrCustomFilter=NULL;
		sfn.nMaxCustFilter=0;
		sfn.nFilterIndex=1;
		sfn.lpstrFile=lpszFn;
		sfn.nMaxFile=255;
		sfn.lpstrFileTitle=lpszFt;
		sfn.nMaxFileTitle=255;
		sfn.lpstrInitialDir=NULL;
		sfn.lpstrTitle=NULL;
		sfn.Flags=0;
		sfn.nFileOffset=0;
		sfn.nFileExtension=0;
		sfn.lpstrDefExt=NULL;
		sfn.lCustData=0;
		sfn.lpfnHook=NULL;
		sfn.lpTemplateName=NULL;
		sfn.lpstrTitle=lpszSave;
		sfn.Flags=OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
		sfn.nFilterIndex=1;

		/* xEChE쐬 */
		hwLabel=CreateWindow("LabelWindow",NULL,
		  WS_CHILD | WS_VISIBLE,0,0,0,0,
		  hwnd,(HMENU)1,g_hInstance,NULL);

		/* gbNo[쐬 */
		hwTrack=CreateWindow(TRACKBAR_CLASS,NULL,
		  WS_CHILD|WS_VISIBLE,0,0,0,0,
		  hwnd,(HMENU)2,g_hInstance,NULL);

		/* XCb`EChE쐬 */
		hwSwitch=CreateWindow("SwitchWindow",NULL,
		  WS_CHILD | WS_VISIBLE,0,0,0,0,
		  hwnd,(HMENU)3,g_hInstance,NULL);

		/* vC{^EChE쐬 */
		hwPlay=CreateWindow("PlayWindow",NULL,
		  WS_CHILD | WS_VISIBLE,0,0,0,0,
		  hwnd,(HMENU)4,g_hInstance,NULL);

		/* |[Y{^EChE쐬 */
		hwPause=CreateWindow("PauseWindow",NULL,
		  WS_CHILD | WS_VISIBLE,0,0,0,0,
		  hwnd,(HMENU)5,g_hInstance,NULL);

		/* Xgbv{^EChE쐬 */
		hwStop=CreateWindow("StopWindow",NULL,
		  WS_CHILD | WS_VISIBLE,0,0,0,0,
		  hwnd,(HMENU)6,g_hInstance,NULL);

		EnableWindow(hwTrack,FALSE);

		GetClientRect(hwnd,&recMain); /* {̃EChȆ傫擾 */
		layout(recMain.right,recMain.bottom);

		hBG=CreateCompatibleBitmap(GetDC(hwnd),recMain.right-2,recMain.bottom-2);
		hdcBG=CreateCompatibleDC(GetDC(hwnd));
		SelectObject(hdcBG,hBG);

		hBMP=CreateCompatibleBitmap(GetDC(hwnd),recMain.right-2,recMain.bottom-2);
		hdcBMP=CreateCompatibleDC(GetDC(hwnd));
		SelectObject(hdcBMP,hBMP);
		FillRect(hdcBMP,&recMain,hBrushM);  /* ŜwiFœhԂ */

		SetTimer(hwnd,1,300,NULL); /* ^C}쐬 */

		break;

	case WM_RBUTTONDOWN: /* E{^NbN */

		/* XN[̃}EXJ[\W擾 */
		pt.x=LOWORD(lParam);
		pt.y=HIWORD(lParam);
		ClientToScreen(hwnd,&pt);

		createList();

		/* J[\ʒuɃj[o */
		TrackPopupMenu(hMenuP,0,pt.x,pt.y,0,hwnd,NULL);

		return 0;

	case WM_HSCROLL: /* gbNo[ʒuύX */

		if (!fOnPlay) /* tłȂΉȂ */
			break;

		/* gbNo[݈̌ʒu擾 */
		pos=SendMessage(hwTrack,TBM_GETPOS,0,0);

		if (dwType==3) {
			vbmp3_seek(pos);
		} else {

			/* t@CV[N */
			wsprintf(lpszStr,"seek music to %d",pos*1000);
			mciSendString(lpszStr,NULL,0,NULL);

			/* V[Nʒu牉tJn */
			mciSendString("play music notify",NULL,0,hwMain);

		}

		break;

	case WM_MOUSEMOVE: /* vC[Ń}EXړ */

		if (!drag) /* hbOłȂΖ߂ */
			break;

		/* vC[́uOvɏohbOI */
		if ((LOWORD(lParam)<0) | (LOWORD(lParam)>recMain.right) |
		  (HIWORD(lParam)<0) | (HIWORD(lParam)>recMain.bottom)) {

			drag=FALSE; /* hbOf */
			ReleaseCapture(); /* }EXLv`[J */

			break;

		}

		GetWindowRect(hwnd,&rec); /* EChËʒu擾 */

		/*@VEChËʒuvZ */
		iDx=rec.left+(LOWORD(lParam)-iOldX);
		iDy=rec.top+(HIWORD(lParam)-iOldY);

		SetWindowPos(hwnd,HWND_TOP,iDx,iDy,
		  0,0,SWP_NOSIZE);

		break;

	case WM_LBUTTONDOWN: /* {^NbN */

		iOldX=LOWORD(lParam); /* }EXJ[\̍WL */
		iOldY=HIWORD(lParam);

		drag=TRUE; /* hbOtOZbg */
		SetCapture(hwnd); /* }EXLv`[Jn */

		break;

	case WM_LBUTTONUP: /* {^Abv */

		drag=FALSE; /* hbOtOZbg */
		ReleaseCapture(); /* }EXLv`[J */

		break;

	case WM_LBUTTONDBLCLK: /* _uNbN */

		CloseWindow(hwMain); /* ŏ */

		break;

	case WM_DROPFILES: /* t@C̃hbv */

		hDrop=(HDROP)wParam; // HDROP擾

		/* hbvꂽt@C擾 */
		dwDNum=DragQueryFile(hDrop,0xFFFFFFFF,NULL,0);

		fRepeat=FALSE;
		CheckMenuItem(hMenuP,11,MF_UNCHECKED);
		
		if (dwDNum==1) { /* hbvꂽt@CP */

			DragQueryFile(hDrop,0,lpszFn,MAX_PATH+1);

			if (lstrcmpi(lpszFn+lstrlen(lpszFn)-4,".bmp")==0) { /* BMP */

				readBMP(lpszFn);

				InvalidateRect(hwnd,NULL,FALSE);
				UpdateWindow (hwnd); /* ĕ` */

			} else if (lstrcmpi(lpszFn+lstrlen(lpszFn)-4,".txt")==0) { // txt

				readTxt(lpszFn);

				if (FileList.size()>0)
					play(-1); /* t@Ct */

			} else {

				DragQueryFile(hDrop,0,lpszFn,MAX_PATH+1);

				if (GetFileAttributes(lpszFn)==FILE_ATTRIBUTE_DIRECTORY) {

					FileList.clear();

					getFiles(lpszFn);

					if (FileList.size()>0)
						play(-1); /* t@Ct */

				} else { /* Pƃt@C */

					/* CTRLL[ĂȂ΃t@CXgNA */
					if (!(GetAsyncKeyState(VK_CONTROL)<0))
						FileList.clear();

					FileList.push_back(lpszFn);

					play(FileList.size()-1);

				}

			}

			DragFinish(hDrop); /* hbOI */

			break;

		} else { /* t@Chbv */

			FileList.clear();
			i=0;

			while (FileList.size()<MAXFILE && i<dwDNum) { /* t@C擾 */

				DragQueryFile(hDrop,i,lpszFn,MAX_PATH+1);

				if (GetFileAttributes(lpszFn)==FILE_ATTRIBUTE_DIRECTORY)
					getFiles(lpszFn);
				else
					FileList.push_back(lpszFn);

				i++;

			}

		}

		DragFinish(hDrop); /* hbOI */

		if (FileList.size()>0)
			play(-1); /* t@Ct */

		break;

	case MM_MCINOTIFY: /* tȈ */

		/* t̐IȊO͉Ȃ */
		if (wParam!=MCI_NOTIFY_SUCCESSFUL)
			break;

		play(-1); /* ߂ĉtJn */

		break;

	case WM_TIMER: /* ^C}bZ[W */

		if (!fOnPlay) /* tłȂΉȂ */
			break;

		if (dwType==3) { /* MP3t */

			if (vbmp3_getState(&w)!=1) { /* ĐԎ擾 */
				
				play(-1);

				break;

			}

			dwPos=w;

		} else { /* MCIŉt */

			/* ݂̉tʒu擾 */
			mciSendString("status music position wait",lpszStr,16,NULL);
			dwPos=(DWORD)(strtol(lpszStr,NULL,10)/1000);

		}

		/* gbNo[Ɍ݂̈ʒuݒ */
		SendMessage(hwTrack,TBM_SETPOS,(WPARAM)1,(LPARAM)dwPos);

		if (dwPos<6000)
			dwTime=dwPos;
		else
			dwTime=5999;

		InvalidateRect(hwnd,&recTime,FALSE);
		UpdateWindow (hwnd);             /* ĕ` */

		break;

	case WM_COMMAND:

		switch (LOWORD(wParam)) {

		case IDM_LOAD: /* t@Cǂݍ݃j[ */

			if (!GetOpenFileName(&ofn)) /* t@CI */
				return 0;

			if (lstrcmpi(lpszFn+lstrlen(lpszFn)-4,".bmp")==0) { /* BMP */

				readBMP(lpszFn);

				InvalidateRect(hwnd,NULL,FALSE);
				UpdateWindow (hwnd); /* ĕ` */

			} else if (lstrcmpi(lpszFn+lstrlen(lpszFn)-4,".txt")==0) { /* txt */

				readTxt(lpszFn); 

				if (FileList.size()>0)
					play(-1); /* t@Ct */

			} else {

				FileList.clear();
				FileList.push_back(lpszFn);

				play(FileList.size()-1);

			}

			break;

		case IDM_SAVE: /* t@Coj[ */

			if (!GetSaveFileName(&sfn)) /* t@CI */
				return 0;

			saveList(lpszFn);

			break;

		case IDM_REPEAT: /* s[gj[ */

			fRepeat=!fRepeat;

			/* Ȗxĕ` */
			InvalidateRect(hwLabel,NULL,FALSE);
			UpdateWindow (hwLabel);

			break;

		case IDM_DELETE: /* ĐXg珜Oj[ */

			if (dwType==0)
				mciSendString("close music",NULL,0,NULL);
			else if (dwType==3)
				vbmp3_close();

			if (fRepeat) {

				fRepeat=FALSE;
				CheckMenuItem(hMenuP,11,MF_UNCHECKED);

			}

			/* t@CXgĐĂt@C폜 */
			FileList.erase(FileList.begin()+dwMIndex);

			if (FileList.size()>0) /* t@CXgɂ܂t@CΉt */
				play(-1);
			else { /* t@CXgɃt@CȂȂΒ~ */

				fPlay=FALSE;
				fOnPlay=FALSE;
				fOnPause=FALSE;
				fOnStop=FALSE;
				title="";
				dwTime=0;

				EnableWindow(hwTrack,FALSE);
				SendMessage(hwTrack,TBM_SETPOS,(WPARAM)1,(LPARAM)0);

				InvalidateRect(hwMain,NULL,FALSE);
				UpdateWindow (hwMain);             /* ĕ` */

			}

			break;

		case IDM_ABOUT: /* o[W񃁃j[ */

			if (fDll)
				MessageBox(hwnd,"BGMt Version 1.49v (C)1998-2004 ˁ@P","o[W",MB_OK);
			else
				MessageBox(hwnd,"BGMt Version 1.49 (C)1998-2004 ˁ@P","o[W",MB_OK);

			break;

		}

		if (LOWORD(wParam)>=20 && LOWORD(wParam)<20+FileList.size()) {

			fRepeat=FALSE;
			play(LOWORD(wParam)-20);

		}

		return 0;

	case WM_PAINT: /* ĕ` */

		hdc=BeginPaint(hwnd,&ps);

		/* `prbg}bvɔwirbg}bvRs[ */
		BitBlt(hdcBG,0,0,recMain.right-2,recMain.bottom-2,hdcBMP,0,0,SRCCOPY);

		SelectObject(hdc,hPenMH);
		MoveToEx(hdc,recMain.right-1,0,NULL);
		LineTo(hdc,0,0);
		LineTo(hdc,0,recMain.bottom-1);

		SelectObject(hdc,hPenMB);
		LineTo(hdc,recMain.right-1,recMain.bottom-1);
		LineTo(hdc,recMain.right-1,0);

		wsprintf(lpszStr,"%02d:%02d/%02d:%02d",
		  dwTime/60,dwTime % 60,dwLength/60,dwLength % 60);

		SetTextColor(hdcBG,RGB(192,255,0));
		SetBkMode(hdcBG,TRANSPARENT);
		SelectObject(hdcBG,hFontTime);
		DrawText(hdcBG,lpszStr,lstrlen(lpszStr),&recTime,
		  DT_RIGHT|DT_SINGLELINE|DT_VCENTER);

		SelectObject(hdcBG,GetStockObject(BLACK_PEN));
		SelectObject(hdcBG,GetStockObject(SYSTEM_FONT));

		BitBlt(hdc,1,1,recMain.right-2,recMain.bottom-2,hdcBG,0,0,SRCCOPY);

		EndPaint(hwnd,&ps);

		break;

	case WM_DESTROY : /* I */

		DestroyMenu(hmList);
		DestroyMenu(hMenuP);
		DestroyMenu(hMenu);

		if (fPlay) { /* tȂ牉tI */

			if (dwType==3) {
				vbmp3_close();
			} else {

				mciSendString("stop music",NULL,0,NULL);
				mciSendString("close music",NULL,0,NULL);

			}

		}

		KillTimer(hwMain,1); /* ^C} */

		DeleteObject(hFontName);
		DeleteObject(hFontTime);
		DeleteObject(hFontNum);
		DeleteObject(hBrushM);
		DeleteObject(hPenMH);
		DeleteObject(hPenMB);
		DeleteObject(hBrushLb);
		DeleteObject(hBrushSw);
		DeleteObject(hBrushBtnB);
		DeleteObject(hBrushBtn);
		DeleteObject(hBrushOn);
		DeleteObject(hBrushOff);
		DeleteObject(hBMP);
		DeleteObject(hBG);
		DeleteDC(hdcBMP);
		DeleteDC(hdcBG);

		if (fDll)
			vbmp3_free();

		PostQuitMessage(0);

		return 0;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

/* xEChEbZ[W */
LRESULT CALLBACK LabelProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {

	HDC hdc;
	PAINTSTRUCT ps;
	RECT recSize,recTitle,recNum;

	switch (iMsg) {

		case WM_PAINT:

			GetWindowRect(hwnd,&recSize);

			recSize.right=recSize.right-recSize.left;
			recSize.bottom=recSize.bottom-recSize.top;
			recSize.left=0;
			recSize.top=0;

			recTitle.left=0;
			recTitle.top=0;
			recTitle.right=recSize.right-48;
			recTitle.bottom=recSize.bottom;

			recNum.left=recSize.right-48;
			recNum.top=0;
			recNum.right=recSize.right;
			recNum.bottom=recSize.bottom-1;

			hdc=BeginPaint(hwnd,&ps);

			FillRect(hdc,&recSize,hBrushLb);

			if (title.size()>0) { /* t@C\ */

				SetTextColor(hdc,RGB(192,255,0));
				SetBkMode(hdc,TRANSPARENT);

				SelectObject(hdc,hFontName);

				DrawText(hdc,title.c_str(),title.size(),&recTitle,
				  DT_CENTER|DT_SINGLELINE|DT_VCENTER|DT_END_ELLIPSIS|DT_MODIFYSTRING);

				TCHAR wrk[10];
				wsprintf(wrk,"%02d/%02d",dwMIndex+1,FileList.size());

				if (fRepeat)
					SetTextColor(hdc,RGB(192,192,192));
				else
					SetTextColor(hdc,RGB(64,224,255));

				SelectObject(hdc,hFontNum);
				DrawText(hdc,wrk,lstrlen(wrk),&recNum,
				  DT_CENTER|DT_SINGLELINE|DT_BOTTOM);

				SelectObject(hdc,GetStockObject(SYSTEM_FONT));

			}

			EndPaint(hwnd,&ps);

			break;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

/* XCb`EChEbZ[W */
LRESULT CALLBACK SwitchProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {

	HDC hdc;
	PAINTSTRUCT ps;
	RECT recSize;

	switch (iMsg) {

		case WM_PAINT:

			GetWindowRect(hwnd,&recSize);

			recSize.right=recSize.right-recSize.left;
			recSize.bottom=recSize.bottom-recSize.top;
			recSize.left=0;
			recSize.top=0;

			hdc=BeginPaint(hwnd,&ps);

			FillRect(hdc,&recSize,hBrushBtnB);

			recSize.left=1;
			recSize.top=1;
			recSize.right-=1;
			recSize.bottom-=1;

			FillRect(hdc,&recSize,hBrushSw);

			EndPaint(hwnd,&ps);

			break;

		case WM_LBUTTONDOWN:

			/* I */
			DestroyWindow(hwMain);

			break;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

LRESULT CALLBACK PlayProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {

	HDC hdc;
	PAINTSTRUCT ps;
	RECT recSize;
	POINT pt[3];

	switch (iMsg) {

		case WM_PAINT:

			GetWindowRect(hwnd,&recSize);

			recSize.right=recSize.right-recSize.left;
			recSize.bottom=recSize.bottom-recSize.top;
			recSize.left=0;
			recSize.top=0;

			pt[0].x=recSize.right/4;
			pt[0].y=recSize.bottom/5;
			pt[1].x=recSize.right/4;
			pt[1].y=(recSize.bottom*3)/4;
			pt[2].x=(recSize.right*4)/5;
			pt[2].y=recSize.bottom/2;

			hdc=BeginPaint(hwnd,&ps);

			FillRect(hdc,&recSize,hBrushBtnB);

			recSize.left=1;
			recSize.top=1;
			recSize.right-=1;
			recSize.bottom-=1;

			FillRect(hdc,&recSize,hBrushBtn);

			if (fOnPlay)
				SelectObject(hdc,hBrushOn);
			else
				SelectObject(hdc,hBrushOff);

			SelectObject(hdc,GetStockObject(BLACK_PEN));

			Polygon(hdc,pt,3);

			SelectObject(hdc,GetStockObject(BLACK_BRUSH));

			EndPaint(hwnd,&ps);

			break;

		case WM_LBUTTONDOWN:

			if (!fPlay ||fOnPlay)
				break;

			if (dwType==0) {

				mciSendString("seek music to start",NULL,0,NULL);
				mciSendString("play music notify",NULL,0,hwMain);

			} else if (dwType==3 && fOnPause) {

				vbmp3_seek(0);
				vbmp3_restart();

			}

			fOnPlay=TRUE;
			fOnPause=FALSE;
			fOnStop=FALSE;
			EnableWindow(hwTrack,TRUE);

			InvalidateRect(hwMain,NULL,FALSE);
			UpdateWindow (hwMain);             /* ĕ` */

			break;

		case WM_LBUTTONDBLCLK: /* _uNbN */

			if (!fOnPlay)
				break;

			play(-1); /* ̃t@Ct */

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

LRESULT CALLBACK PauseProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {

	HDC hdc;
	PAINTSTRUCT ps;
	RECT recSize,rec;

	switch (iMsg) {

		case WM_PAINT:

			GetWindowRect(hwnd,&recSize);

			recSize.right=recSize.right-recSize.left;
			recSize.bottom=recSize.bottom-recSize.top;
			recSize.left=0;
			recSize.top=0;

			hdc=BeginPaint(hwnd,&ps);

			FillRect(hdc,&recSize,hBrushBtnB);

			recSize.left=1;
			recSize.top=1;
			recSize.right-=1;
			recSize.bottom-=1;

			FillRect(hdc,&recSize,hBrushBtn);

			rec.left=(++recSize.right*2)/7;
			rec.top=++recSize.bottom/4;
			rec.right=(recSize.right*3)/7;
			rec.bottom=(recSize.bottom*3)/4;

			if (fOnPause)
				FillRect(hdc,&rec,hBrushOn);
			else
				FillRect(hdc,&rec,hBrushOff);

			FrameRect(hdc,&rec,hBrushOff);

			rec.left=(recSize.right*4)/7;
			rec.top=recSize.bottom/4;
			rec.right=(recSize.right*5)/7;
			rec.bottom=(recSize.bottom*3)/4;

			if (fOnPause)
				FillRect(hdc,&rec,hBrushOn);
			else
				FillRect(hdc,&rec,hBrushOff);

			FrameRect(hdc,&rec,hBrushOff);

			EndPaint(hwnd,&ps);

			break;

		case WM_LBUTTONDOWN:

			if (!fPlay || fOnStop)
				break;

			if (fOnPause) { /* |[YȂ牉tĊJ */

				if (dwType==3)
					vbmp3_restart();
				else
					mciSendString("play music notify",NULL,0,hwMain);

				fOnPause=FALSE;
				fOnPlay=TRUE;
				EnableWindow(hwTrack,TRUE);

			} else { /* tȂ|[Y */

				if (dwType==3)
					vbmp3_pause();
				else
					mciSendString("pause music",NULL,0,NULL);

				fOnPlay=FALSE;
				fOnPause=TRUE;
				EnableWindow(hwTrack,FALSE);

			}

			InvalidateRect(hwMain,NULL,FALSE);
			UpdateWindow (hwMain);             /* ĕ` */

			break;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

LRESULT CALLBACK StopProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {

	HDC hdc;
	PAINTSTRUCT ps;
	RECT recSize,rec;

	switch (iMsg) {

		case WM_PAINT:

			GetWindowRect(hwnd,&recSize);

			recSize.right=recSize.right-recSize.left;
			recSize.bottom=recSize.bottom-recSize.top;
			recSize.left=0;
			recSize.top=0;

			hdc=BeginPaint(hwnd,&ps);

			FillRect(hdc,&recSize,hBrushBtnB);

			recSize.left=1;
			recSize.top=1;
			recSize.right-=1;
			recSize.bottom-=1;

			FillRect(hdc,&recSize,hBrushBtn);

			rec.left=(++recSize.right*2)/7;
			rec.top=++recSize.bottom/4;
			rec.right=(recSize.right*5)/7;
			rec.bottom=(recSize.bottom*3)/4;

			FillRect(hdc,&rec,hBrushOff);

			EndPaint(hwnd,&ps);

			break;

		case WM_LBUTTONDOWN:

			if ((!fOnPlay && !fOnPause) || fOnStop)
				break;

			if (dwType==0) {

				mciSendString("stop music",NULL,0,NULL);
				mciSendString("seek music to start wait",NULL,0,NULL);

			} else if (dwType==3) {

				vbmp3_stop();
				vbmp3_seek(0);

			}

			fOnPlay=FALSE;
			fOnPause=FALSE;
			fOnStop=TRUE;
			SendMessage(hwTrack,TBM_SETPOS,(WPARAM)1,(LPARAM)0);
			EnableWindow(hwTrack,FALSE);

			InvalidateRect(hwMain,NULL,FALSE);
			UpdateWindow (hwMain);           /* ĕ` */

			break;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

void play(int iNo) { /* t@CXg̋Ȃt */

	char lpszCmd[MAX_PATH+32],lpszLength[17];
	DWORD dwErr,dwW;

	if (FileList.size()<1)
		return;

	if (iNo>=0)
		dwMIndex=iNo;
	else {

		if (dwMIndex>=FileList.size())
			dwMIndex=0;

		if (!fRepeat) {

			dwW=dwMIndex;

			dwMIndex=rand() % FileList.size();

			if (dwMIndex==dwW) /* OƓȂȂxI */
				dwMIndex=rand() % FileList.size();

		}

	}

	if (fPlay && dwType==0) /* ݃foCXI[vԂȂN[Y */
		mciSendString("close music wait",NULL,0,NULL);
	else if (fPlay && dwType==3)
		vbmp3_close();

	if (FileList[dwMIndex].size()<4 || FileList[dwMIndex].size()>MAX_PATH) { /* t@C */

		/* t@CXg玸st@C폜 */
		FileList.erase(FileList.begin()+dwMIndex);

		if (FileList.size()>0) /* t@CXgɂ܂t@CΉt */
			play(-1);
		else { /* t@CXgɃt@CȂȂΒ~ */

			fPlay=FALSE;
			fOnPlay=FALSE;
			fOnPause=FALSE;
			fOnStop=FALSE;
			title="";
			dwTime=0;

			EnableWindow(hwTrack,FALSE);
			SendMessage(hwTrack,TBM_SETPOS,(WPARAM)1,(LPARAM)0);

			InvalidateRect(hwMain,NULL,FALSE);
			UpdateWindow (hwMain);             /* ĕ` */

		}

		return;

	}

	// MP3
	if ((lstrcmpi(FileList[dwMIndex].substr(FileList[dwMIndex].size()-4,4).c_str(),".mp3")==0) & fDll) {

		Sleep(5);
		vbmp3_open(FileList[dwMIndex].c_str(),&mInfo);

		dwLength=mInfo.totalSec; /* ĐԎ擾 */
		dwType=3;

		if (vbmp3_play())
			dwErr=0;
		else
			dwErr=1;

		if (dwErr==1) {

			vbmp3_close();
			Sleep(5);
			vbmp3_open(FileList[dwMIndex].c_str(),&mInfo);

			dwLength=mInfo.totalSec; /* ĐԎ擾 */
			dwType=3;

			if (vbmp3_play())
				dwErr=0;

		}

		InvalidateRect(hwMain,NULL,FALSE);
		UpdateWindow (hwMain);             /* ĕ` */

	} else { /* MP3ȊOMCIōĐ */

		if (fPlay) /* ݃foCXI[vԂȂN[Y */
			mciSendString("close music wait",NULL,0,NULL);

		Sleep(5);

		lstrcpy(lpszCmd,"open "); /* t@CI[v */
		lstrcat(lpszCmd,"\"");
		lstrcat(lpszCmd,FileList[dwMIndex].c_str());
		lstrcat(lpszCmd,"\"");
		lstrcat(lpszCmd," alias music wait");

		dwErr=mciSendString(lpszCmd,NULL,0,NULL);
		dwType=0;

	}

	if (dwErr!=0) { /* I[vs */

		if (dwType==0)
			mciSendString("close music",NULL,0,NULL);
		else if (dwType==3)
			vbmp3_close();

		/* t@CXg玸st@C폜 */
		FileList.erase(FileList.begin()+dwMIndex);

		if (FileList.size()>0) /* t@CXgɂ܂t@CΉt */
			play(-1);
		else { /* t@CXgɃt@CȂȂΒ~ */

			fPlay=FALSE;
			fOnPlay=FALSE;
			fOnPause=FALSE;
			fOnStop=FALSE;
			title="";
			dwTime=0;

			EnableWindow(hwTrack,FALSE);
			SendMessage(hwTrack,TBM_SETPOS,(WPARAM)1,(LPARAM)0);

			InvalidateRect(hwMain,NULL,FALSE);
			UpdateWindow (hwMain);             /* ĕ` */

		}

		return;

	}

	if (dwType==0) { /* MCIĐ̍ĐԎ擾EĐ */

		/* foCX̎ԒPʂ~bɐݒ */
		mciSendString("set music time format milliseconds wait",NULL,0,NULL);

		/* foCX̉tԂ擾 */
		mciSendString("status music length wait",lpszLength,16,NULL);
		dwLength=(DWORD)(strtol(lpszLength,NULL,10)/1000);

		mciSendString("play music notify",NULL,0,hwMain); /* tJn */

	}

	/* gbNo[͈̔͂tԂɐݒ */
	SendMessage(hwTrack,TBM_SETRANGEMAX,(WPARAM)1,(LPARAM)dwLength);
	/* gbNo[ŏɐݒ */
	SendMessage(hwTrack,TBM_SETPOS,(WPARAM)1,(LPARAM)0);

	/* t@CpXt@Ĉ݂擾^Cgɐݒ */
	title=FileList[dwMIndex];
	if (title.rfind("\\")>0) // \\ȍ~^Cg
		title=title.substr(title.rfind("\\")+1,title.size()-title.rfind("\\"));

	fPlay=TRUE; /* ԃtOݒ */
	fOnPlay=TRUE;
	fOnPause=FALSE;
	fOnStop=FALSE;

	EnableWindow(hwTrack,TRUE);
	dwTime=0;
	SendMessage(hwTrack,TBM_SETPOS,(WPARAM)1,(LPARAM)0);

	InvalidateRect(hwMain,NULL,FALSE);
	UpdateWindow (hwMain);             /* ĕ` */

}

BOOL readBMP(LPCTSTR fn) { /* rbg}bvǂݍ */

	DWORD offset,dummy;
	LPBYTE lpDIB,lpPixel;
	LPBITMAPINFO lpInfo;

	HANDLE fh;

	fh=CreateFile(fn,GENERIC_READ,0,NULL,OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,NULL); /* t@CI[v */

	if (fh==INVALID_HANDLE_VALUE)
		return FALSE;

	lpDIB=(LPBYTE)GlobalAlloc
	    (GPTR,GetFileSize(fh,NULL)); /* obt@m */

	ReadFile(fh,lpDIB,GetFileSize(fh,NULL),&dummy,NULL);

	lpInfo=(LPBITMAPINFO)(lpDIB+sizeof(BITMAPFILEHEADER));

	offset=*(LPDWORD)(lpDIB+10);
	lpPixel=lpDIB+offset; /* rbg}bvobt@̐擪AhX */

	CloseHandle(fh);

	/* QSrbgtJ[rbg}bvłȂΖ */
	if (lpDIB[0]!='B' || lpInfo->bmiHeader.biBitCount!=24) {

		GlobalFree(lpDIB);

		return FALSE;

	}

	/* wirbg}bvɓǂ݂񂾃rbg}bv` */
	StretchDIBits(hdcBMP,0,0,recMain.right-2,recMain.bottom-2,
	  0,0,lpInfo->bmiHeader.biWidth,lpInfo->bmiHeader.biHeight,
	  lpPixel,lpInfo,DIB_RGB_COLORS,SRCCOPY);

	GlobalFree(lpDIB);

	return TRUE;

}

bool readTxt(LPCTSTR lpszFn) {

	FILE *fp;
	int i=0;
	char tmp[512];

	FileList.clear();

	fp=fopen(lpszFn,"r");

	if (fp==NULL)
		return false;

	while (FileList.size()<MAXFILE && fgets(tmp,512,fp)!=NULL) { /* t@C擾 */

		if ((strlen(tmp))>0)
			tmp[(strlen(tmp))-1]=0;

		if (GetFileAttributes(tmp)==FILE_ATTRIBUTE_DIRECTORY)
			getFiles(tmp);
		else
			FileList.push_back(tmp);

		i++;

	}

	return true;

}

void createList(void) {

	string stWrk;

	DestroyMenu(hmList);
	DestroyMenu(hMenuP);
	DestroyMenu(hMenu);

	hMenuP=CreatePopupMenu(); // t[eBOj[
	hmList=CreateMenu();

	for (DWORD i=0;i<FileList.size();i++) {

		stWrk=FileList[i];

		if (stWrk.rfind("\\")>0) // \\ȍ~^Cg
			stWrk=stWrk.substr(stWrk.rfind("\\")+1,stWrk.size()-stWrk.rfind("\\"));

		AppendMenu(hmList,MF_STRING,20+i,stWrk.c_str());

	}

	// t[eBOj[쐬
	AppendMenu(hMenuP,MF_STRING,IDM_LOAD,"t@Cǂݍ");
	AppendMenu(hMenuP,MF_STRING,IDM_SAVE,"ĐXgo");
	AppendMenu(hMenuP,MF_STRING,IDM_REPEAT,"s[g");
	AppendMenu(hMenuP,MF_STRING,IDM_DELETE,"ĐXg珜O");

	if (FileList.size()>0) {

		AppendMenu(hMenuP,MF_POPUP,(UINT)hmList,"ĐXg");
		CheckMenuItem(hmList,20+dwMIndex,MF_CHECKED);

	} else {

		EnableMenuItem(hMenuP,IDM_SAVE,MF_GRAYED);
		EnableMenuItem(hMenuP,IDM_DELETE,MF_GRAYED);

	}

	AppendMenu(hMenuP,MF_SEPARATOR,0,NULL);
	AppendMenu(hMenuP,MF_STRING,IDM_ABOUT,"o[W");

	if (FileList.size()<2)
		EnableMenuItem(hMenuP,IDM_REPEAT,MF_GRAYED);

	if (fRepeat)
		CheckMenuItem(hMenuP,IDM_REPEAT,MF_CHECKED);
	else
		CheckMenuItem(hMenuP,IDM_REPEAT,MF_UNCHECKED);

}

void saveList(LPCTSTR lpszPath) { /* t@CXgo */

	ofstream osList(lpszPath);

	for (vector<string>::const_iterator i=FileList.begin();i!=FileList.end();i++)
		osList << *i << "\n";

	osList.close();

}

