#define INFO_NAME_SIZE		128
#define MSG_ERROR 0;
#define MSG_PLAYING  1
#define MSG_PAUSING  2
#define MSG_STOPDONE 3
#define MSG_PLAYDONE 4

struct InputInfo {
	char	szTrackName[INFO_NAME_SIZE];
	char	szArtistName[INFO_NAME_SIZE];
	int		channels,bitRate,samplingRate,totalSec;
};

typedef void (__stdcall *INPUT_MSG_PROC)(int msg, int param);
typedef BOOL (CALLBACK* FINIT)();
typedef int (CALLBACK* FVERSION)();
typedef BOOL (CALLBACK* FOPEN)(const char*,InputInfo*);
typedef BOOL (CALLBACK* FPLAY)();
typedef BOOL (CALLBACK* FSTATE)(int*);
typedef BOOL (CALLBACK* FCLOSE)();
typedef BOOL (CALLBACK* FPAUSE)();
typedef BOOL (CALLBACK* FSTOP)();
typedef BOOL (CALLBACK* FRESTART)();
typedef BOOL (CALLBACK* FSEEK)(int);
typedef BOOL (CALLBACK* FFREE)();
typedef BOOL (CALLBACK* FCALL)(INPUT_MSG_PROC);

FINIT pInit;
FVERSION pVersion;
FOPEN pOpen;
FPLAY pPlay;
FPAUSE pPause;
FSTOP pStop;
FRESTART pRestart;
FSTATE pState;
FSEEK pSeek;
FCLOSE pClose;
FFREE pFree;
FCALL pCall;

HINSTANCE hDLL=NULL;

BOOL __stdcall vbmp3_init() {

    if (hDLL==NULL) {

        hDLL=LoadLibrary("VBMP3.dll");

		if (hDLL==NULL)
			return FALSE;

        pInit=(FINIT)GetProcAddress(hDLL,"vbmp3_init");
        pVersion=(FINIT)GetProcAddress(hDLL,"vbmp3_getVersion");
        pOpen=(FOPEN)GetProcAddress(hDLL,"vbmp3_open");
        pPlay=(FPLAY)GetProcAddress(hDLL,"vbmp3_play");
        pState=(FSTATE)GetProcAddress(hDLL,"vbmp3_getState");
        pPause=(FPAUSE)GetProcAddress(hDLL,"vbmp3_pause");
        pStop=(FSTOP)GetProcAddress(hDLL,"vbmp3_stop");
        pRestart=(FRESTART)GetProcAddress(hDLL,"vbmp3_restart");
        pSeek=(FSEEK)GetProcAddress(hDLL,"vbmp3_seek");
        pClose=(FCLOSE)GetProcAddress(hDLL,"vbmp3_close");
        pFree=(FFREE)GetProcAddress(hDLL,"vbmp3_free");
        pCall=(FCALL)GetProcAddress(hDLL,"vbmp3_clallback");

    }

    return pInit();

}

int __stdcall vbmp3_getVersion() {

	return pVersion();

}

BOOL __stdcall vbmp3_open(const char* pszName, InputInfo* pInfo) {

	return pOpen(pszName,pInfo);

}

BOOL __stdcall vbmp3_play() {

	return pPlay();

}

BOOL __stdcall vbmp3_pause() {

	return pPause();

}

BOOL __stdcall vbmp3_stop() {

	return pStop();

}

BOOL __stdcall vbmp3_restart() {

	return pRestart();

}

BOOL __stdcall vbmp3_close() {

	return pClose();

}

BOOL __stdcall vbmp3_getState(int* sec) {

	return pState(sec);

}

BOOL __stdcall vbmp3_seek(int sec) {

	return pSeek(sec);

}

BOOL __stdcall vbmp3_free() {

	return pFree();

}

BOOL __stdcall vbmp3_callback(INPUT_MSG_PROC pProc) {

	return pCall(pProc);

}
